#ifndef RCL_CL_ARGS_HPP
#define RCL_CL_ARGS_HPP

#include <vector>
#include <string>

#include "cl_args_e.hpp"

namespace arg {
    class CL_Args {
    public:
	CL_Args(int argc, char* argv[]);

	void readCL() throw();
	    // throw (arg::SetOutput, arg::FromList, arg::ArgsError, arg::Input, arg::FromBasename);

	void debug() const;
	void printAll() const;
	void printHelp() const;
	void printVersion(int major, int minor) const;
	
	bool usingOutfile() const;
	bool usingListfile() const;
	bool usingBasename() const;
	
	bool setOutput() const    { return this->setoutput;    }
	bool fromList() const     { return this->fromlist;     }
	bool fromBasename() const { return this->frombasename; }
	bool Verbose() const      { return this->verbose;      }
	bool Help() const         { return this->help;         }
	bool Sort() const         { return this->sort;         }
	bool Version() const      { return this->version;      }
	
	std::string Outfile() const  { return this->outfile;  }
	std::string Listfile() const { return this->listfile; }
	std::string Basename() const { return this->basename; }
	
	int Count() const {return this->count; }
    private:
	CL_Args(const CL_Args&){}
	CL_Args& operator=(const CL_Args&);

	bool setoutput;
	bool fromlist;
	bool frombasename;
	bool verbose;
	bool help;
	bool sort;
	bool version;
	
	std::string outfile;
	std::string listfile;
	std::string basename;
	
	int count;
	char** ch_array;
	std::vector<std::string> arguments;
	std::vector<std::string> switches;
	
	void parseArgs() throw(); // throw (arg::SetOutput, arg::FromList, arg::ArgsError);
	bool isSwitch(std::string str);
	bool noValidSwitches();
	bool argsOK() throw(); // throw (arg::Input, arg::FromBasename);
    };
    
}
#endif
    
