#include <iostream>
#include "df3_e.hpp"

df3::DF3Error::~DF3Error(){;}

void df3::DF3Error::debug() const 
{
    std::cout << "Unknown DF3 Error\n";
}


void df3::OutputError::debug() const
{
    std::cout << "Unable to write DF3 output file " << this->filename << "\n";
}

df3::MismatchError::MismatchError(std::string filename, int df3_w, int df3_h, int df3_t,
		   int tga_w, int tga_h, int tga_t)
{
    this->filename = filename;
    this->df3_w = df3_w;
    this->df3_h = df3_h;
    this->df3_t = df3_t;
    this->tga_w = tga_w;
    this->tga_h = tga_h;
    this->tga_t = tga_t;
}

void df3::MismatchError::debug() const
{
    std::cout << "\nERROR:\tInconsistent attribute"
	      << " in file " << this->filename << "\n"
	      << "ERROR:\tExpecting: " << this->df3_w << "x" << this->df3_h 
	      << " Type=" << this->df3_t << "\n"
	      << "ERROR:\tRecieved : " << this->tga_w << "x" << this->tga_h
	      << " Type=" << this->tga_t << "\n"
	      << "ERROR:\t\n"
	      << "ERROR:\tIf you created these TGA files manually, be sure\n" 
	      << "ERROR:\tto save them all with the same properties.\n"
	      << "\nDF3 File not created.\n";
}
